
#ifndef __PATH_INC
#define __PATH_INC

class ENGINE_API FPathBuilder
{
public:
	
	int buildPaths (ULevel *ownerLevel, int optimization);
	int removePaths (ULevel *ownerLevel);
	int showPaths (ULevel *ownerLevel);
	int hidePaths (ULevel *ownerLevel);
	void definePaths (ULevel *ownerLevel);
	void undefinePaths (ULevel *ownerLevel);

//private:
	class FPathMarker *pathMarkers;
	ULevel * Level;
	APawn * Scout;
	INT	numMarkers;

	void CheckDoor(AActor *Node);
	int createPaths (int optimization);
	void	newPath(FVector spot);
	INT addMarker();
	void createPathsFrom(FVector start);
	void checkObstructionFrom(FPathMarker *marker);
	int checkmergeSpot(const FVector &spot, FPathMarker *path1, FPathMarker *path2);
	void mergePath(INT iMarker);
	void exploreWall(FVector moveDirection);
	int walkToward(const FVector &Destination, FLOAT Movesize);
	void followWall(FVector currentDirection);
	int checkLeft(FVector &leftDirection, FVector &currentDirection);
	int checkLeftPassage(FVector &currentDirection);
	int fullyReachable(FVector start, FVector destination);
	int boundedReachable(FVector start,FVector destination);
	int needPath(const FVector &start);
	int sawNewLeft(const FVector &start);
	int oneWaypointTo(const FVector &upstreamSpot);
	void markLeftReachable(const FVector &start);
	void markReachable(const FVector &start);
	int markReachableFromTwo(FPathMarker *path1, FPathMarker *path2);
	int tryPathThrough(FPathMarker *Waypoint, const FVector &Destination, FLOAT budget);
	int findPathTo(const FVector &Destination);
	void addReachSpecs(AActor * start);
	void FindBlockingNormal(FVector &BlockNormal);
	void addVisNoReach(AActor * start);
};

class XC_ENGINE_API FXC_PathBuilder : public FPathBuilder
{
public:
	void definePaths_XC( ULevel *ownerLevel);
	void undefinePaths_XC ( ULevel *ownerLevel);

	void addReachSpecs(AActor * start);
	void addVisNoReach(AActor * start);
	int findScoutStart(FVector start);
	int Prune(AActor *Node);
	void getScout();
	INT specFor(AActor* Start, AActor* End);
	int insertReachSpec(INT *SpecArray, FReachSpec &Spec);
};



#if _MSC_VER
#pragma pack (push,4)
#endif


class XC_ENGINE_API AXC_PathBuilder : public AXC_Engine_Actor
{
public:
	FXC_PathBuilder Builder;

	FLOAT MaxScanRange;
	UClass* InventorySpotType;

	void StaticConstructor();
	void InitExecution();
	

	
	NO_DEFAULT_CONSTRUCTOR(AXC_PathBuilder)
	DECLARE_CLASS(AXC_PathBuilder,AActor,/*CLASS_Transient*/0,XC_Engine)
};



#if _MSC_VER
#pragma pack (pop)
#endif

#endif